/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2005-2012 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: exception.c 50 2012-09-07 03:47:18Z ertl-hiro $
 */

/*
 *		CPU㳰ǽ
 */

#include "kernel_impl.h"
#include "check.h"
#include "task.h"
#include "exception.h"

/*
 *  ȥ졼ޥΥǥե
 */
#ifndef LOG_DEF_EXC_ENTER
#define LOG_DEF_EXC_ENTER(excno, pk_dexc)
#endif /* LOG_DEF_EXC_ENTER */

#ifndef LOG_DEF_EXC_LEAVE
#define LOG_DEF_EXC_LEAVE(ercd)
#endif /* LOG_DEF_EXC_LEAVE */

#ifndef LOG_XSNS_DPN_ENTER
#define LOG_XSNS_DPN_ENTER(p_excinf)
#endif /* LOG_XSNS_DPN_ENTER */

#ifndef LOG_XSNS_DPN_LEAVE
#define LOG_XSNS_DPN_LEAVE(state)
#endif /* LOG_XSNS_DPN_LEAVE */

#ifndef LOG_XSNS_XPN_ENTER
#define LOG_XSNS_XPN_ENTER(p_excinf)
#endif /* LOG_XSNS_XPN_ENTER */

#ifndef LOG_XSNS_XPN_LEAVE
#define LOG_XSNS_XPN_LEAVE(state)
#endif /* LOG_XSNS_XPN_LEAVE */

#ifdef TOPPERS_excini

/*
 *  CPU㳰ϥɥ֥åΥꥢ
 */
EXCINIB	excinib_table[TNUM_EXCNO];

/* 
 *  CPU㳰ϥɥǽν
 */
void
initialize_exception(void)
{
	uint_t	i;

	for (i = 0; i < TNUM_EXCNO; i++) {
		excinib_table[i].excatr = TA_NOEXS;
	}
}

#endif /* TOPPERS_excini */

/*
 *  CPU㳰ϥɥ
 */
#ifdef TOPPERS_def_exc

ER
def_exc(EXCNO excno, const T_DEXC *pk_dexc)
{
	EXCINIB	*p_excinib;
	ER		ercd;

	LOG_DEF_EXC_ENTER(excno, pk_dexc);
	CHECK_INIRTN();
	CHECK_PAR(VALID_EXCNO_DEFEXC(excno));
	CHECK_RSATR(pk_dexc->excatr, TARGET_EXCATR);
	CHECK_NOSPT(pk_dexc->exchdr != NULL);
	CHECK_ALIGN_FUNC(pk_dexc->exchdr);
	CHECK_NONNULL_FUNC(pk_dexc->exchdr);
	p_excinib = get_excinib(excno);

	if (p_excinib->excatr != TA_NOEXS) {
		ercd = E_OBJ;
	}
	else if ((ercd = target_check_dexc(excno, pk_dexc)) == E_OK) {
		p_excinib->excatr = pk_dexc->excatr;
		p_excinib->exchdr = pk_dexc->exchdr;
	}

  error_exit:
	LOG_DEF_EXC_LEAVE(ercd);
	return(ercd);
}

#endif /* TOPPERS_def_exc */

/*
 *  CPU㳰ȯƥȤλ
 */

/*
 *  CPU㳰ȯΥǥѥåα֤λ
 *
 *  CPU㳰ϥɥdisdspѲ뤳ȤϤʤᡤCPU㳰ȯ
 *  disdsp¸ƤɬפϤʤ
 */
#ifdef TOPPERS_xsns_dpn

bool_t
xsns_dpn(void *p_excinf)
{
	bool_t	state;

	LOG_XSNS_DPN_ENTER(p_excinf);
	state = (exc_sense_intmask(p_excinf) && !disdsp) ? false : true;
	LOG_XSNS_DPN_LEAVE(state);
	return(state);
}

#endif /* TOPPERS_xsns_dpn */

/*
 *  CPU㳰ȯΥ㳰α֤λ
 *
 *  CPU㳰ϥɥp_runtskp_runtsk->enatexѲ뤳ȤϤʤ
 *  ᡤCPU㳰ȯp_runtsk->enatex¸ƤɬפϤ
 *  
 */
#ifdef TOPPERS_xsns_xpn

bool_t
xsns_xpn(void *p_excinf)
{
	bool_t	state;

	LOG_XSNS_XPN_ENTER(p_excinf);
	state = (exc_sense_intmask(p_excinf) && p_runtsk->enatex) ? false : true;
	LOG_XSNS_XPN_LEAVE(state);
	return(state);
}

#endif /* TOPPERS_xsns_xpn */
